package cn.iocoder.yudao.module.system.service.tenantbalance;

import java.util.*;
import javax.validation.*;
import cn.iocoder.yudao.module.system.controller.admin.tenantbalance.vo.*;
import cn.iocoder.yudao.module.system.dal.dataobject.tenantbalance.TenantBalanceDO;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.pojo.PageParam;

/**
 * 租户余额 Service 接口
 *
 * @author 总后台
 */
public interface TenantBalanceService {

    /**
     * 创建租户余额
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createTenantBalance(@Valid TenantBalanceSaveReqVO createReqVO);

    /**
     * 更新租户余额
     *
     * @param updateReqVO 更新信息
     */
    void updateTenantBalance(@Valid TenantBalanceSaveReqVO updateReqVO);

    /**
     * 删除租户余额
     *
     * @param id 编号
     */
    void deleteTenantBalance(Long id);

    /**
    * 批量删除租户余额
    *
    * @param ids 编号
    */
    void deleteTenantBalanceListByIds(List<Long> ids);

    /**
     * 获得租户余额
     *
     * @param id 编号
     * @return 租户余额
     */
    TenantBalanceDO getTenantBalance(Long id);

    /**
     * 获得租户余额分页
     *
     * @param pageReqVO 分页查询
     * @return 租户余额分页
     */
    PageResult<TenantBalanceRespVO> getTenantBalancePage(TenantBalancePageReqVO pageReqVO);

    void addTenantBalance(@Valid TenantBalanceAddReqVO updateReqVO);

    void transferToTenant(@Valid TenantBalanceTransferReqVO transferReqVO);

    TenantBalanceDO getSelfBalance();

    PageResult<TenantBalanceRespVO> getSelfSubordinateTenantBalancePage(@Valid TenantBalancePageReqVO pageReqVO);

    Boolean consumption(Long PackageId, Long targetTenantId,String remark);

    Boolean reduceTestAccountNum(Long currentTenantId, String remark);

    Boolean addTestAccountNum(Long currentTenantId, String remark);
}